;----------------------------------------------------------------------------------------------------------
; CountDown\2_Select.asm
;----------------------------------------------------------------------------------------------------------
; Hauptprogramm

MLoop:
		rjmp	outDek

;----------------------------------------------------------------------------------------------------------
; Eingabe von Werten in die Dekaden
; Interrupt Auslsung durch Drcken und Loslassen der Taste 2, d.h. durch die Flanke 0 V --> + 5 V

onInt0:
		ldi		Contr1	,	0b00000001
		reti
		
;----------------------------------------------------------------------------------------------------------
; Weiterschaltung zur nchsten Dekade, nach der letzten Dekade Start des Runterzhlens
; Interrupt Auslsung durch Drcken und Loslassen der Taste 1, d.h. durch die Flanke 0 V --> + 5 V

onInt1:
		rjmp	outDek
		reti

;----------------------------------------------------------------------------------------------------------
; Dekade whlen

outDek:	
		ldi		Temp	,	0b11000000		; Bit 6 = 1: Int0 aktiv
		out		GICR	,	Temp			; Bit 7 = 1: Int1 aktiv
Dek_0:
		inc		Contr0
		cpi		Contr0	,	0b00000001		; Stunden  x 10
		breq	Dek_1
		cpi		Contr0	,	0b00000010		; Stunden  x  1
		breq	Dek_2
		cpi		Contr0	,	0b00000011		; Minuten  x 10
		breq	Dek_3
		cpi		Contr0	,	0b00000100		; Minuten  x  1
		breq	Dek_4
		cpi		Contr0	,	0b00000101		; Sekunden x 10
		breq	Dek_5
		cpi		Contr0	,	0b00000110		; Sekunden x  1
		breq	Dek_6
		sbis	PIND	,	5				; D.5 = Low:  Betrieb mit 6 Dekaden: [HH:MM:SS]
											; D.5 = High: Betrieb mit 8 Dekaden: [HH:MM:SS.ss]
		rjmp	Dek_9
		cpi		Contr0	,	0b00000111		; Sekunden x  0.10
		breq	Dek_7
		cpi		Contr0	,	0b00001000		; Sekunden x  0.01
		breq	Dek_8
		cpi		Contr0	,	0b00001001		; Neueingabe oder Count Down Beginn
		breq	Dek_9
Dek_1:
		rjmp	Dek01
Dek_2:
		rjmp	Dek02
Dek_3:
		rjmp	Dek03
Dek_4:
		rjmp	Dek04
Dek_5:
		rjmp	Dek05
Dek_6:
		rjmp	Dek06
Dek_7:
		rjmp	Dek07
Dek_8:
		rjmp	Dek08
Dek_9:
;		sbi		PORTD	,	6				; Relais: Wischer 10 ms
;		ldi		Time	,	0b00000001		; dient zum Starten der Stoppuhr.
;		rcall	Wait						; Aktivierung:
;		cbi		PORTD	,	6				; durch Beseitigung der Semikolons am Anfang der Zeilen.

		sei									; Interrupt Ein
		ldi		Temp	,	0b00000000		; Bit 6 = 0: Int0 nicht aktiv
		out		GICR	,	Temp			; Bit 7 = 0: Int1 nicht aktiv
		ldi		Temp	,	0b00000010		; Bit 1 = 1: Prescaler 8
		out		TCCR0	,	Temp			;
		ldi		Temp	,	0b00000001		; Bit 0 = 1: Timer0 Overflow
		out		TIMSK	,	Temp			; Timer0 aktiv
Dek_:
		rjmp	Dek_

;----------------------------------------------------------------------------------------------------------
; Stunden x 10
; gewhlt werden knnen 0, 10 oder 20 Stunden

Dek01:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek10
		brne	Dek14
Dek10:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun1
		cpi		Temp	,	0b00000000
		breq	Dek11
		cpi		Temp	,	0b00000001
		breq	Dek12
		cpi		Temp	,	0b00000010
		breq	Dek13
		rjmp	Dek14
Dek11:
		ldi		Temp	,	0b00000001
		mov		mCoun1	,	Temp
		rjmp	Dek14
Dek12:
		ldi		Temp	,	0b00000010
		mov		mCoun1	,	Temp
		rjmp	Dek14
Dek13:
		ldi		Temp	,	0b00000000
		mov		mCoun1	,	Temp
		rjmp	Dek14
Dek14:
		rcall	Dunk01
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell01
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek01

;----------------------------------------------------------------------------------------------------------
; Stunden x 1
; wenn bei "Stunden x 10" 0 oder 10 Stunden gewhlt wurde, knnen 0 bis 9        Stunden gewhlt werden
; wenn bei "Stunden x 10"        20 Stunden gewhlt wurde, knnen 0, 1, 2 oder 3 Stunden gewhlt werden
; die lngste whlbare Zeit soll 23:59:59.99 [HH:MM:SS.ss] sein, jedoch mu z.B. 19:59:59.99 mglich sein

Dek02:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek200
		brne	Dek211
Dek200:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun2
		cpi		Temp	,	0b00000000
		breq	Dek201
		cpi		Temp	,	0b00000001
		breq	Dek202
		cpi		Temp	,	0b00000010
		breq	Dek203

		push	Temp
		mov		Temp	,	mCoun1
		cpi		Temp	,	0b00000010
		breq	Dek210
		pop		Temp

		cpi		Temp	,	0b00000011
		breq	Dek204
		cpi		Temp	,	0b00000100
		breq	Dek205
		cpi		Temp	,	0b00000101
		breq	Dek206
		cpi		Temp	,	0b00000110
		breq	Dek207
		cpi		Temp	,	0b00000111
		breq	Dek208
		cpi		Temp	,	0b00001000
		breq	Dek209
		cpi		Temp	,	0b00001001
		breq	Dek210
		rjmp	Dek211
Dek201:
		ldi		Temp	,	0b00000001
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek202:
		ldi		Temp	,	0b00000010
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek203:
		ldi		Temp	,	0b00000011
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek204:
		ldi		Temp	,	0b00000100
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek205:
		ldi		Temp	,	0b00000101
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek206:
		ldi		Temp	,	0b00000110
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek207:
		ldi		Temp	,	0b00000111
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek208:
		ldi		Temp	,	0b00001000
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek209:
		ldi		Temp	,	0b00001001
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek210:
		ldi		Temp	,	0b00000000
		mov		mCoun2	,	Temp
		rjmp	Dek211
Dek211:
		rcall	Dunk02
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell02
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek02

;----------------------------------------------------------------------------------------------------------
; Minuten x 10
; gewhlt werden knnen 0, 10, 20, 30, 40 oder 50 Minuten

Dek03:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek30
		brne	Dek37
Dek30:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun3
		cpi		Temp	,	0b00000000
		breq	Dek31
		cpi		Temp	,	0b00000001
		breq	Dek32
		cpi		Temp	,	0b00000010
		breq	Dek33
		cpi		Temp	,	0b00000011
		breq	Dek34
		cpi		Temp	,	0b00000100
		breq	Dek35
		cpi		Temp	,	0b00000101
		breq	Dek36
		rjmp	Dek37
Dek31:
		ldi		Temp	,	0b00000001
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek32:
		ldi		Temp	,	0b00000010
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek33:
		ldi		Temp	,	0b00000011
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek34:
		ldi		Temp	,	0b00000100
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek35:
		ldi		Temp	,	0b00000101
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek36:
		ldi		Temp	,	0b00000000
		mov		mCoun3	,	Temp
		rjmp	Dek37
Dek37:
		rcall	Dunk03
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell03
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek03

;----------------------------------------------------------------------------------------------------------
; Minuten x 1
; gewhlt werden knnen 0, 1, 2 usw. bis 9 Minuten

Dek04:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek400
		brne	Dek411
Dek400:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun4
		cpi		Temp	,	0b00000000
		breq	Dek401
		cpi		Temp	,	0b00000001
		breq	Dek402
		cpi		Temp	,	0b00000010
		breq	Dek403
		cpi		Temp	,	0b00000011
		breq	Dek404
		cpi		Temp	,	0b00000100
		breq	Dek405
		cpi		Temp	,	0b00000101
		breq	Dek406
		cpi		Temp	,	0b00000110
		breq	Dek407
		cpi		Temp	,	0b00000111
		breq	Dek408
		cpi		Temp	,	0b00001000
		breq	Dek409
		cpi		Temp	,	0b00001001
		breq	Dek410
		rjmp	Dek411
Dek401:
		ldi		Temp	,	0b00000001
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek402:
		ldi		Temp	,	0b00000010
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek403:
		ldi		Temp	,	0b00000011
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek404:
		ldi		Temp	,	0b00000100
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek405:
		ldi		Temp	,	0b00000101
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek406:
		ldi		Temp	,	0b00000110
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek407:
		ldi		Temp	,	0b00000111
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek408:
		ldi		Temp	,	0b00001000
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek409:
		ldi		Temp	,	0b00001001
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek410:
		ldi		Temp	,	0b00000000
		mov		mCoun4	,	Temp
		rjmp	Dek411
Dek411:
		rcall	Dunk04
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell04
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek04

;----------------------------------------------------------------------------------------------------------
; Sekunden x 10
; gewhlt werden knnen 0, 10, 20, 30, 40 oder 50 Sekunden

Dek05:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek50
		brne	Dek57
Dek50:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun5
		cpi		Temp	,	0b00000000
		breq	Dek51
		cpi		Temp	,	0b00000001
		breq	Dek52
		cpi		Temp	,	0b00000010
		breq	Dek53
		cpi		Temp	,	0b00000011
		breq	Dek54
		cpi		Temp	,	0b00000100
		breq	Dek55
		cpi		Temp	,	0b00000101
		breq	Dek56
		rjmp	Dek57
Dek51:
		ldi		Temp	,	0b00000001
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek52:
		ldi		Temp	,	0b00000010
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek53:
		ldi		Temp	,	0b00000011
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek54:
		ldi		Temp	,	0b00000100
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek55:
		ldi		Temp	,	0b00000101
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek56:
		ldi		Temp	,	0b00000000
		mov		mCoun5	,	Temp
		rjmp	Dek57
Dek57:
		rcall	Dunk05
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell05
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek05

;----------------------------------------------------------------------------------------------------------
; Sekunden x 1
; gewhlt werden knnen 0, 1, 2 usw. bis 9 Sekunden

Dek06:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek600
		brne	Dek611
Dek600:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun6
		cpi		Temp	,	0b00000000
		breq	Dek601
		cpi		Temp	,	0b00000001
		breq	Dek602
		cpi		Temp	,	0b00000010
		breq	Dek603
		cpi		Temp	,	0b00000011
		breq	Dek604
		cpi		Temp	,	0b00000100
		breq	Dek605
		cpi		Temp	,	0b00000101
		breq	Dek606
		cpi		Temp	,	0b00000110
		breq	Dek607
		cpi		Temp	,	0b00000111
		breq	Dek608
		cpi		Temp	,	0b00001000
		breq	Dek609
		cpi		Temp	,	0b00001001
		breq	Dek610
		rjmp	Dek611
Dek601:
		ldi		Temp	,	0b00000001
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek602:
		ldi		Temp	,	0b00000010
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek603:
		ldi		Temp	,	0b00000011
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek604:
		ldi		Temp	,	0b00000100
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek605:
		ldi		Temp	,	0b00000101
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek606:
		ldi		Temp	,	0b00000110
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek607:
		ldi		Temp	,	0b00000111
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek608:
		ldi		Temp	,	0b00001000
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek609:
		ldi		Temp	,	0b00001001
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek610:
		ldi		Temp	,	0b00000000
		mov		mCoun6	,	Temp
		rjmp	Dek611
Dek611:
		rcall	Dunk06
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell06
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek06

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.10
; gewhlt werden knnen 0, 0.1, 0.2 usw. bis 0.9 Sekunden

Dek07:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek700
		brne	Dek711
Dek700:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun7
		cpi		Temp	,	0b00000000
		breq	Dek701
		cpi		Temp	,	0b00000001
		breq	Dek702
		cpi		Temp	,	0b00000010
		breq	Dek703
		cpi		Temp	,	0b00000011
		breq	Dek704
		cpi		Temp	,	0b00000100
		breq	Dek705
		cpi		Temp	,	0b00000101
		breq	Dek706
		cpi		Temp	,	0b00000110
		breq	Dek707
		cpi		Temp	,	0b00000111
		breq	Dek708
		cpi		Temp	,	0b00001000
		breq	Dek709
		cpi		Temp	,	0b00001001
		breq	Dek710
		rjmp	Dek711
Dek701:
		ldi		Temp	,	0b00000001
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek702:
		ldi		Temp	,	0b00000010
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek703:
		ldi		Temp	,	0b00000011
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek704:
		ldi		Temp	,	0b00000100
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek705:
		ldi		Temp	,	0b00000101
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek706:
		ldi		Temp	,	0b00000110
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek707:
		ldi		Temp	,	0b00000111
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek708:
		ldi		Temp	,	0b00001000
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek709:
		ldi		Temp	,	0b00001001
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek710:
		ldi		Temp	,	0b00000000
		mov		mCoun7	,	Temp
		rjmp	Dek711
Dek711:
		rcall	Dunk07
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell07
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek07

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.01
; gewhlt werden knnen 0, 0.01, 0.02 usw. bis 0.09 Sekunden

Dek08:
		sei
		cpi		Contr1	,	0b00000001
		breq	Dek800
		brne	Dek811
Dek800:
		ldi		Contr1	,	0b00000000
		mov		Temp	,	mCoun8
		cpi		Temp	,	0b00000000
		breq	Dek801
		cpi		Temp	,	0b00000001
		breq	Dek802
		cpi		Temp	,	0b00000010
		breq	Dek803
		cpi		Temp	,	0b00000011
		breq	Dek804
		cpi		Temp	,	0b00000100
		breq	Dek805
		cpi		Temp	,	0b00000101
		breq	Dek806
		cpi		Temp	,	0b00000110
		breq	Dek807
		cpi		Temp	,	0b00000111
		breq	Dek808
		cpi		Temp	,	0b00001000
		breq	Dek809
		cpi		Temp	,	0b00001001
		breq	Dek810
		rjmp	Dek811
Dek801:
		ldi		Temp	,	0b00000001
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek802:
		ldi		Temp	,	0b00000010
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek803:
		ldi		Temp	,	0b00000011
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek804:
		ldi		Temp	,	0b00000100
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek805:
		ldi		Temp	,	0b00000101
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek806:
		ldi		Temp	,	0b00000110
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek807:
		ldi		Temp	,	0b00000111
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek808:
		ldi		Temp	,	0b00001000
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek809:
		ldi		Temp	,	0b00001001
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek810:
		ldi		Temp	,	0b00000000
		mov		mCoun8	,	Temp
		rjmp	Dek811
Dek811:
		rcall	Dunk08
		ldi		Time	,	0b00001100
		rcall	Wait
		rcall	Hell08
		ldi		Time	,	0b00001100
		rcall	Wait
		rjmp	Dek08

;----------------------------------------------------------------------------------------------------------
