;----------------------------------------------------------------------------------------------------------
; CountDown\4_Digits.asm
;----------------------------------------------------------------------------------------------------------
; Das CONTROL WORD des ICM7218 wird ausgegeben.

outCon:
		push	Contr0
		ldi		Contr0	,	0b00000100		; Data Coming, Decode, Code B
		out		PORTC	,	Contr0			; (Shutdown not wired)
		sbr		Contr0	,	0b00110000		; MODE   = High: Load Control Bits on /WRITE LOW Pulse
		out		PORTB	,	Contr0			; /WRITE = High: Input Not Loaded
		ldi		Contr0	,	0b00100000		; MODE   = High: Load Control Bits on /WRITE LOW Pulse
		out		PORTB	,	Contr0			; /WRITE = Low : Input Loaded       = /WRITE LOW Pulse ON
		ldi		Contr0	,	0b00110000		; MODE   = High: Load Control Bits on /WRITE LOW Pulse
		out		PORTB	,	Contr0			; /WRITE = High: Input Not Loaded   = /WRITE LOW Pulse OFF
		pop		Contr0
		ret

;----------------------------------------------------------------------------------------------------------
; Die HEX-Codes fr die 7-Segment - Anzeigen werden ausgegeben

outDig:
		push	Contr1
		mov		Contr1	,	Number			; MODE   = Low : Load Input Data
		sbr		Contr1	,	0b00010000		; /WRITE = High: Input Not Loaded
		out		PORTB	,	Contr1			; 
		mov		Contr1	,	Number			; MODE   = Low : Load Input Data
		cbr		Contr1	,	0b00010000		; /WRITE = Low : Input Loaded
		out		PORTB	,	Contr1			; /WRITE = Low : /WRITE LOW Pulse ON
		mov		Contr1	,	Number			; MODE   = Low : Load Input Data
		sbr		Contr1	,	0b00010000		; /WRITE = High: Input Not Loaded
		out		PORTB	,	Contr1			; /WRITE = High: /WRITE LOW Pulse OFF
		pop		Contr1
		ret

;----------------------------------------------------------------------------------------------------------
; Wartezeit: Time = 1 ==> 0.01 s, Time = 255 ==> 2.55 s.

Wait:
		push	Contr0
		push	Contr1
		cpi		Time	,	0
		breq	WLoop0
WLoop1:
		ldi		Contr0	,	0b01101110
WLoop2:
		ldi		Contr1	,	0b01101110
WLoop3:
		dec		Contr1
		brne	WLoop3
		nop
		nop
		dec		Contr0
		brne	WLoop2
		dec		Time
		brne	WLoop1
WLoop0:
		pop		Contr1
		pop		Contr0
		ret

;----------------------------------------------------------------------------------------------------------
