;----------------------------------------------------------------------------------------------------------
; CountDown\5_Timer.asm
;----------------------------------------------------------------------------------------------------------
; Timer:	Normalbetrieb:	(PORT D.4 = High) jede Sekunde wird "LTim00" 100 mal aufgerufen.
;			Debug-Betrieb:	(PORT D.4 = Low)  jede Sekunde wird "LTim00"   1 mal aufgerufen.
;
; Die nachfolgende Rechnung gilt, wenn D.4 = Low ist (Debug-Betrieb)
;
; Prozessortakt	: 3.686.100	Hz		: 3.686.400	/	8	/ 256	=	1.800	Hz
; Prescaler		: 8					:			1.800	/	2	=	  900	Hz	mTimr1 (C.3) Ein-Aus
; Zhlstufen	: 256				:			1.800	/  90	=	   20	Hz	mTimr2		 gerechnet
; C.3			: 900,0000	Hz		:				20	/	2	=	   10	Hz	mTimr2 (C.4) Ein-Aus
; C.4			:  10,0000	Hz		:				20	/  10	=		2	Hz	mTimr3		 gerechnet
; C.5			:   1,0000	Hz		:				2	/	2	=		1	Hz	mTimr3 (C.5) Ein-Aus
;----------------------------------------------------------------------------------------------------------

onTc0:
		rcall	LTim00	
reti

;----------------------------------------------------------------------------------------------------------
; Relais Ein und Aus, Sound
; Die Relais-Funktion kann zum Wischer gendert werden, zum Stoppen der Stoppuhr.
; Dafr auch die Wischer-Funktion in 2_Select.asm aktivieren und die Relais Ein Funktion hier deaktivieren.

LTim00:
		sbi		PORTD	,	6				; Relais Ein
		mov		Temp	,	mCoun8			; Bedingung fr das Abschalten der Relais:
		cpi		Temp	,	0b00000000		; wenn alle Dekaden auf 0 stehen.
		brne	LTim01						; Wischfunktion des Relais fr die Stoppuhr Start:
		mov		Temp	,	mCoun7			; s. in 2_Select.asm.
		cpi		Temp	,	0b00000000		; Dafr mu hier die 1. Zeile unter LTime00
		brne	LTim01						; auskommentiert werden.
		mov		Temp	,	mCoun6			; Das Relais kann hier nicht den Soppuhr Start auslsen,
		cpi		Temp	,	0b00000000		; weil LTimm 100 Mal pro Sekunde aufgerufen wird.
		brne	LTim01
		mov		Temp	,	mCoun5
		cpi		Temp	,	0b00000000
		brne	LTim01
		mov		Temp	,	mCoun4
		cpi		Temp	,	0b00000000
		brne	LTim01
		mov		Temp	,	mCoun3
		cpi		Temp	,	0b00000000
		brne	LTim01
		mov		Temp	,	mCoun2
		cpi		Temp	,	0b00000000
		brne	LTim01
		mov		Temp	,	mCoun1
		cpi		Temp	,	0b00000000
		brne	Ltim01
;		sbi		PORTD	,	6				; | Relais Ein fr Wischer 10 ms fr die  Stoppuhr Stopp
;		ldi		Time	,	0b00000001		; | Zur Aktivierung der Funktion Stoppuhr Stopp:
;		rcall	Wait						; | diese drei Zeilen Entfernen der Semikolons vorne.
		cbi		PORTD	,	6				; Relais Aus
		rjmp	Sound

;----------------------------------------------------------------------------------------------------------
; 1. Teil: 900 Hz ausgeben an C.3

LTim01:
		mov		Freq00	,	mTimr1
		cpi		Freq00	,	0
		breq	LTim02
		mov		Freq00	,	mTimr1
		cpi		Freq00	,	1
		breq	LTim03
LTim02:
		sbi		PORTC	,	3				; LED fr die Anzeige von 900 Hz Ein
		ldi		Freq00	,	1
		mov		mTimr1	,	Freq00
		rjmp	LTim04
LTim03:
		cbi		PORTC	,	3				; LED fr die Anzeige von 900 Hz Aus
		ldi		Freq00	,	0
		mov		mTimr1	,	Freq00
LTim04:
		in		Temp	,	PIND			; D.4 = High: 900 Hz / 9  = 100 Hz
		sbrs	Temp	,	4				; D.4 = Low:  900 Hz / 90 =  10 Hz
		rjmp	LTim05
		mov		Freq00	,	mTimr4
		inc		Freq00
		mov		mTimr4	,	Freq00
		cpi		Freq00	,	9				; Divisor fr 100 Hz
		breq	LTim10
		rjmp	TimeEnd
LTim05:
		mov		Freq00	,	mTimr4
		inc		Freq00
		mov		mTimr4	,	Freq00
		cpi		Freq00	,	90				; Divisor fr   1 Hz
		breq	LTim10
		rjmp	TimeEnd

;----------------------------------------------------------------------------------------------------------
; 2. Teil:  Wenn D.4 = High, 100 Hz, keine	Ausgabe an C.4
;			wenn D.4 = Low,   10 Hz, 		Ausgabe an C.4 (Debug-Betrieb)

LTim10:	
		mov		mTimr4	,	Freq00
		mov		Freq00	,	mTimr2
		cpi		Freq00	,	0
		breq	LTim11
		mov		Freq00	,	mTimr2
		cpi		Freq00	,	1
		breq	LTim12
LTim11:
		sbi		PORTC	,	4				; LED fr die Anzeige von 10 Hz Ein (nur im Debug-Betrieb)
		ldi		Freq00	,	1
		mov		mTimr2	,	Freq00
		rjmp	LTim13
LTim12:
		cbi		PORTC	,	4				; LED fr die Anzeige von 10 Hz Aus (nur im Debug-Betrieb)
		ldi		Freq00	,	0
		mov		mTimr2	,	Freq00
LTim13:
		ldi		Freq00	,	0
		mov		mTimr4	,	Freq00
LTim14:	
		in		Temp	,	PIND			; D.4 = High: 100 Hz / 1  = 100 Hz
		sbrs	Temp	,	4				; D.4 = Low:   10 Hz / 10 =   1 Hz
		rjmp	LTim15
		mov		Freq00	,	mTimr5
		inc		Freq00
		mov		mTimr5	,	Freq00
		cpi		Freq00	,	1				; Divisor fr 100 Hz
		breq	LTim20
		rjmp	TimeEnd
LTim15:
		mov		Freq00	,	mTimr5
		inc		Freq00
		mov		mTimr5	,	Freq00
		cpi		Freq00	,	10				; Divisor fr   1 Hz
		breq	LTim20
		rjmp	TimeEnd

;----------------------------------------------------------------------------------------------------------
; 3. Teil:	Wenn D.4 = High, 100 Hz ausgeben an C.5
;			wenn D.4 = Low,    1 Hz ausgeben an C.5, dient zum Debuggen

LTim20:
		mov		mTimr5	,	Freq00
		mov		Freq00	,	mTimr3
		cpi		Freq00	,	0
		breq	LTim21
		mov		Freq00	,	mTimr3
		cpi		Freq00	,	1
		breq	LTim22
LTim21:
		rcall	CountDown				; Runterzhlen
		sbi		PORTC	,	5			; LED fr die Anzeige von 100 Hz bzw. 1 Hz Ein
		ldi		Freq00	,	1
		mov		mTimr3	,	Freq00
		rjmp	LTim23
LTim22:
		cbi		PORTC	,	5			; LED fr die Anzeige von 100 Hz bzw. 1 Hz Aus
		ldi		Freq00	,	0
		mov		mTimr3	,	Freq00
LTim23:
		ldi		Freq00	,	0
		mov		mTimr5	,	Freq00

;----------------------------------------------------------------------------------------------------------

TimeEnd:
		ret

;----------------------------------------------------------------------------------------------------------
; Sound  Programmende mit Summton ca. 460 Hertz, ca. 2 Sekunden und Ausgabe von Blanks an alle Dekaden.
;        Neustart durch gleichzeitiges Drcken beider Tasten, das lst einen Hardware-Reset aus.

Sound:
		cli
Sound1:
		ldi		Temp	,	0b00000010
		ldi		Time	,	0b11111111
		ldi		Contr0	,	0b00000000
		ldi		Contr1	,	0b00000000
		ldi		Number	,	0b00000000
		ldi		Help00	,	0b00000000
		ldi		Freq00	,	0b00000000
		ldi		Temp01	,	0b00000000
Sound3:
		cpi		Temp01	,	0b00000001
		breq	Sound1
		ldi		Temp01	,	0b00000001
		in		Freq00	,	PIND
		sbrs	Freq00	,	7
		sbi		PORTD	,	7
		in		Freq00	,	PIND
		sbrc	Freq00	,	7
		cbi		PORTD	,	7
Sound4:
		ldi		Contr0	,	0b00111111
Sound5:
		ldi		Contr1	,	0b00111111
Sound6:
		dec		Contr1
		brne	Sound6
		dec		Contr0
		brne	Sound5
Sound7:
		ldi		Temp01	,	0b00000000
		cbi		PORTD	,	7
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		dec		Time
		brne	Sound3
Sound8:
		dec		Temp
		brne	Sound3
Sound9:
		rjmp	Sound9

;----------------------------------------------------------------------------------------------------------
